format PE64 GUI 6.0
include "WIN64W.INC"
include "EXTIMPORT.INC"
include "GDIPLUS.INC"
library KERNEL32.DLL,USER32.DLL,GDIPLUS.DLL
import	KERNEL32.DLL	    = "KERNEL32.DLL",\
	ExitProcess	    = "ExitProcess",\
	GetLastError	    = "GetLastError",\
	SetLastError	    = "SetLastError"
import	USER32.DLL	    = "USER32.DLL",\
	BeginPaint	    = "BeginPaint",\
	CreateWindowExW     = "CreateWindowExW",\
	DefWindowProcW	    = "DefWindowProcW",\
	DispatchMessageW    = "DispatchMessageW",\
	EndPaint	    = "EndPaint",\
	GetMessageW	    = "GetMessageW",\
	LoadImage	    = "LoadImageW",\
	PostQuitMessage     = "PostQuitMessage",\
	RegisterClassExW    = "RegisterClassExW",\
	TranslateMessage    = "TranslateMessage"
import	GDIPLUS.DLL	    = "GDIPLUS.DLL",\
	GdipAddPathLineI    = "GdipAddPathLineI",\
	GdipCreateFromHWND  = "GdipCreateFromHWND",\
	GdipCreatePath	    = "GdipCreatePath",\
	GdipDeleteGraphics  = "GdipDeleteGraphics",\
	GdipCreatePen1	    = "GdipCreatePen1",\
	GdipDeletePath	    = "GdipDeletePath",\
	GdipDeletePen	    = "GdipDeletePen",\
	GdipDrawLineI	    = "GdipDrawLineI",\
	GdipDrawPath	    = "GdipDrawPath",\
	GdipDrawRectangleI  = "GdipDrawRectangleI",\
	GdipSetPenDashArray = "GdipSetPenDashArray",\
	GdipSetPenLineJoin  = "GdipSetPenLineJoin",\
	GdipSetPenMode	    = "GdipSetPenMode",\
	GdipSetPenEndCap    = "GdipSetPenEndCap",\
	GdipSetPenStartCap  = "GdipSetPenStartCap",\
	GdipStartPathFigure = "GdipStartPathFigure",\
	GdiplusShutdown     = "GdiplusShutdown",\
	GdiplusStartup	    = "GdiplusStartup"
section '.data' data readable writeable
gsi	       GdiplusStartupInput 1,0,0,0,0
gdipDash       dd  1.0,\
		   0.5
nativePenWidth dd  3.0
blackPenWidth  dd  1.0
greenPenWidth  dd 10.0
hPenWidth      dd  8.0
hPen0Width     dd 10.0
szClassName    du "GDI+  ",0
szFileName     du "br_Rabbit3.cur",0
align 8
gdipGraphics   rq 1
gdipPath       rq 1
hPen0	       rq 1
hPen	       rq 1
nativePen      rq 1
blackPen       rq 1
greenPen       rq 1
gdiplusToken   rd 1
virtual        at 0
  wce	       WNDCLASSEX
  label WNDCLASSEXW.Length
end virtual
section '.text' code readable executable
label ImageBase at $ - $$
entry	WinMain
proc WinMain
  RegisterClassExW_SizeAndStyle = WNDCLASSEXW.Length or ((CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS or CS_DBLCLKS) shl 32)
  local msg:MSG
	frame
	GdiplusStartup gdiplusToken, gsi, 0
	LoadImage NULL, addr szFileName, IMAGE_CURSOR, LR_DEFAULTSIZE, LR_DEFAULTSIZE, LR_LOADFROMFILE or LR_SHARED
	RegisterClassExW addr rsp + 32, rdx, r8, r9, RegisterClassExW_SizeAndStyle,\
			 addr WndProc, NULL, addr ImageBase, rax, rax, COLOR_WINDOWFRAME+1,\
			 NULL, addr szClassName, rax
	CreateWindowExW  WS_EX_TOOLWINDOW, addr szClassName, addr szClassName,\
			 WS_OVERLAPPEDWINDOW or WS_VISIBLE, 100, 100, 400, 400,\
			 NULL, NULL, addr ImageBase, NULL
	SetLastError NULL
	jmp	.start

  @@:
	TranslateMessage addr msg
	DispatchMessageW addr msg

  .start:
	GetMessageW addr msg, NULL, NULL, NULL
	inc	eax
	jz	@f
	dec	eax
	jnz	@b
	mov	eax, dword [msg.wParam]
	jmp	.exit

  @@:
	GetLastError

  .exit:
	GdiplusShutdown [gdiplusToken]
	ExitProcess eax
	endf
endp

proc	WndProc, hWnd:QWORD,uMsg:DWORD,wPar:QWORD,lPar:QWORD
	frame
  local ps:PAINTSTRUCT
	cmp	edx, WM_PAINT
	jz	.wm_paint
	cmp	edx, WM_DESTROY
	jz	.wm_destroy
	cmp	edx, WM_CREATE
	jz	.wm_create
	DefWindowProcW rcx, edx, r8, r9
	jmp	.quit

  .wm_create:
	GdipCreateFromHWND rcx, gdipGraphics
	GdipCreatePen1 0FF00FF00h, float [nativePenWidth], UnitWorld, addr nativePen
	GdipCreatePen1 0FF000000h, float [blackPenWidth], UnitWorld, addr blackPen
	GdipCreatePen1 0FF00FF00h, float [greenPenWidth], UnitWorld, addr greenPen
	GdipSetPenMode [greenPen], PenAlignmentCenter
	GdipCreatePen1 0FFFFFF00h, float [hPenWidth], UnitWorld, addr hPen
	GdipSetPenStartCap  [hPen], LineCapRoundAnchor
	GdipSetPenEndCap    [hPen], LineCapArrowAnchor
	GdipCreatePath	  0, addr gdipPath
	GdipStartPathFigure [gdipPath]
	GdipCreatePen1 0FFFF0000h, float [hPen0Width], UnitWorld, addr hPen0
	GdipSetPenStartCap  [hPen0], LineCapRoundAnchor
	GdipSetPenEndCap    [hPen0], LineCapArrowAnchor
	GdipSetPenDashArray [hPen0], addr gdipDash, 2
	xor	eax, eax
	jmp	.quit

  .wm_destroy:
	GdipDeletePen	   [hPen0]
	GdipDeletePen	   [hPen]
	GdipDeletePen	   [greenPen]
	GdipDeletePen	   [blackPen]
	GdipDeletePen	   [nativePen]
	GdipDeletePath	   [gdipPath]
	GdipDeleteGraphics [gdipGraphics]
	PostQuitMessage NULL
	jmp	.quit

  .wm_paint:

	mov [hWnd], rcx
	BeginPaint, [hWnd], addr ps
; 
	GdipDrawLineI  [gdipGraphics], [nativePen], 40, 40, 200, 100 ;x1,y1,x2,y2
;"" 
	GdipDrawLineI [gdipGraphics], [greenPen], 230, 200, 300, 150
	GdipDrawLineI [gdipGraphics], [blackPen], 230, 200, 300, 150
;     
	GdipDrawRectangleI [gdipGraphics], [greenPen], 210, 220, 100, 100
	GdipDrawRectangleI [gdipGraphics], [blackPen], 210, 220, 100, 100
;     
	GdipSetPenMode [greenPen], PenAlignmentInset
	GdipDrawRectangleI [gdipGraphics], [greenPen], 250, 250, 100, 100
	GdipDrawRectangleI [gdipGraphics], [blackPen], 250, 250, 100, 100
; 
	GdipDrawLineI [gdipGraphics], [hPen], 12, 92, 60, 80
; 
	GdipAddPathLineI [gdipPath],  10, 200, 100, 200
	GdipAddPathLineI [gdipPath], 100, 200, 100, 300
	GdipAddPathLineI [gdipPath], 100, 300, 150, 300
	GdipSetPenLineJoin [hPen], LineJoinBevel
	GdipDrawPath [gdipGraphics], [hPen], [gdipPath]
; 
	GdipDrawLineI [gdipGraphics], [hPen0], 100, 50, 200, 50
	GdipDrawLineI [gdipGraphics], [hPen0], 100, 70, 300, 70
;------------------------------------------------------------
	EndPaint, [hWnd], addr ps

	jmp	.quit

  .quit:
	endf
	ret
endp
